<?php
// knihovna funkcí

// pošle serveru požadavek na pohyb s aktuálním ID hry
function pohyb($p)
{
	return request("tah?id=".$GLOBALS['hra']."&pohyb=$p");
}

// pošle hernímu serveru GET request na zadané URL a vrátí výsledek
function request($url)
{
	$ch = curl_init("http://".$GLOBALS['adresa_serveru']."/$url");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$r = curl_exec($ch);
	curl_close($ch);
	return $r;
}

// parsuje odpověď serveru
// vrátí asociované pole s informacemi o počtu tahů, hráčů, bodů a hracím poli
function parse($s)
{
	$řádky = substr_count($s = trim($s), "\n") + 1;
	if($řádky < 10)
		return $s;
	
	$s = explode("\n", str_replace("\r", "", $s));
	$r = array('id' => (int)trim($s[0]), 'tahy' => (int)trim($s[1]));
	
	// parsování pole
	$r['pole'] = array();
	for($i = 2; $i < 12; $i++)
	{
		$r['pole'][$i-1] = array();
		for($j = 1; $j <= 10; $j++)
		{
			$co = null;
			switch($pole = substr($s[$i], ($j-1)*2, 2))
			{
				case "..":
					$co = ".";
					break;
				case "XX":
					$co = "x";
					break;
				case "++":
					$co = "+";
					break;
				case "--":
					$co = "-";
					break;
				default:
					$co = (int)$pole;
					break;
			}
			$r['pole'][$i-1][$j] = $co;
		}
	}
	
	// informace o prvním hráči
	$p = explode(" ", trim($s[12]));
	$r[1] = array('x' => (int)$p[0], 'y' => (int)$p[1], 'p' => (int)$p[2], 'c' => (int)$p[3]);
	
	// informace o druhém hráči
	if($řádky == 14)
	{
		$p = explode(" ", trim($s[13]));
		$r[2] = array('x' => (int)$p[0], 'y' => (int)$p[1], 'p' => (int)$p[2], 'c' => (int)$p[3]);
	}
	
	return $r;
}

// nakreslí hrací pole
function pole($s)
{
	$p = $s['pole'];
	echo '<table><tr><th></th>';
	for($i = 1; $i <= 10; $i++) echo '<th></th>';
	echo '<th></th></tr>';
	for($i = 1; $i <= 10; $i++)
	{
		echo '<tr><th></th>';
		for($j = 1; $j <= 10; $j++)
		{
			if($j == $s[1]['x'] && $i == $s[1]['y']) echo '<th id="a"></th>';
			elseif(isset($s[2]) && $j == $s[2]['x'] && $i == $s[2]['y']) echo '<th id="b"></th>';
			elseif($p[$i][$j] == 'x') echo '<th></th>';
			elseif($p[$i][$j] == '.') echo '<td></td>';
			elseif(is_numeric($p[$i][$j])) echo '<td>'.$p[$i][$j].'</td>';
			elseif($p[$i][$j] == '+') echo '<td class="a"></td>';
			elseif($p[$i][$j] == '-') echo '<td class="b"></td>';
			else echo '<td>e</td>';
		}
		echo '<th></th></tr>';
	}
	echo '<tr><th></th>';
	for($i = 1; $i <= 10; $i++) echo '<th></th>';
	echo '<th></th></tr></table>';
}

// odkud_x, odkud_y, kam_x, kam_y, pole
function najdi_cestu($i, $j, $x, $y)
{
	global $cesta, $s;
	if($x > 10 || $x < 1 || $y > 10 || $y < 1) return false;
	if($i == $x && $j == $y) return true;
	if($s['pole'][$y][$x] == 'x' || $s['pole'][$y][$x] == '-') return false;
	if(in_array(array($x, $y), $cesta)) return false;
	$cesta[] = array($x, $y);
	if(najdi_cestu($i, $j, $x-1, $y)) return true;
	if(najdi_cestu($i, $j, $x, $y+1)) return true;
	if(najdi_cestu($i, $j, $x+1, $y)) return true;
	if(najdi_cestu($i, $j, $x, $y-1)) return true;
	unset($cesta[array_search(array($x, $y), $cesta)]);
	return false;
}

// vrátí souřadnice nejbližšího pokladu
function najdi_poklad($x, $y, $p)
{
	$x_ = $y_ = 0;
	$r_ = 2147483647; // to není keyboard smash, ale 2^31-1, horní limit signed integeru
	for($i = 1; $i <= 10; $i++)
		for($j = 1; $j <= 10; $j++)
			if(is_numeric($p[$i][$j]))
			{
				$r = sqrt(pow($j-$x, 2) + pow($i-$y, 2)); // vzdálenost od pokladu
				if($r < $r_)
				{
					$r_ = $r;
					$x_ = $j;
					$y_ = $i;
				}	
			}
	return array($x_, $y_);
}